std::__basic_future< _Res > Class Template Reference
Concurrency » Futures
Inheritance diagram for std::__basic_future< _Res >:
[legend]

## Public Types

template<typename _Res >
using | _Ptr = unique_ptr< _Res, _Result_base::_Deleter >
using | _State_base = _State_baseV2

## Public Member Functions

| __basic_future (const __basic_future &)=delete
__basic_future & | operator= (const __basic_future &)=delete
bool | valid () const noexcept
void | wait () const
template<typename _Rep , typename _Period >
future_status | wait_for (const chrono::duration< _Rep, _Period > &__rel) const
template<typename _Clock , typename _Duration >
future_status | wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Static Public Member Functions

template<typename _Res , typename _Allocator >
static _Ptr< _Result_alloc< _Res, _Allocator > > | _S_allocate_result (const _Allocator &__a)
template<typename _Res , typename _Tp >
static _Ptr< _Result< _Res > > | _S_allocate_result (const std::allocator< _Tp > &__a)
template<typename _BoundFn >
static std::shared_ptr< _State_base > | _S_make_async_state (_BoundFn &&__fn)
template<typename _BoundFn >
static std::shared_ptr< _State_base > | _S_make_deferred_state (_BoundFn &&__fn)
template<typename _Res_ptr , typename _BoundFn >
static _Task_setter< _Res_ptr, _BoundFn > | _S_task_setter (_Res_ptr &__ptr, _BoundFn &__call)

## Protected Types

typedef __future_base::_Result< _Res > & | __result_type
typedef shared_ptr< _State_base > | __state_type

## Protected Member Functions

| __basic_future (const __state_type &__state)
| __basic_future (const shared_future< _Res > &) noexcept
| __basic_future (shared_future< _Res > &&) noexcept
| __basic_future (future< _Res > &&) noexcept
__result_type | _M_get_result () const
void | _M_swap (__basic_future &__that) noexcept

## Detailed Description

### template<typename _Res>
class std::__basic_future< _Res >

Common implementation for future and shared_future.

Definition at line 660 of file future.

## Member Typedef Documentation

## _Ptr

template<typename _Res >

using std::__future_base::_Ptr = unique_ptr<_Res, _Result_base::_Deleter>

inherited

A unique_ptr for result objects.

Definition at line 214 of file future.

## Member Function Documentation

## _M_get_result()

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | const

inline protected

Wait for the state to be ready and rethrow any stored exception.

Definition at line 703 of file future.

The documentation for this class was generated from the following file:

- future